# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class Gateway(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, name: str=None, latitude: float=None, longitude: float=None):  # noqa: E501
        """Gateway - a model defined in Swagger

        :param name: The name of this Gateway.  # noqa: E501
        :type name: str
        :param latitude: The latitude of this Gateway.  # noqa: E501
        :type latitude: float
        :param longitude: The longitude of this Gateway.  # noqa: E501
        :type longitude: float
        """
        self.swagger_types = {
            'name': str,
            'latitude': float,
            'longitude': float
        }

        self.attribute_map = {
            'name': 'name',
            'latitude': 'latitude',
            'longitude': 'longitude'
        }
        self._name = name
        self._latitude = latitude
        self._longitude = longitude

    @classmethod
    def from_dict(cls, dikt) -> 'Gateway':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Gateway of this Gateway.  # noqa: E501
        :rtype: Gateway
        """
        return util.deserialize_model(dikt, cls)

    @property
    def name(self) -> str:
        """Gets the name of this Gateway.


        :return: The name of this Gateway.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this Gateway.


        :param name: The name of this Gateway.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def latitude(self) -> float:
        """Gets the latitude of this Gateway.


        :return: The latitude of this Gateway.
        :rtype: float
        """
        return self._latitude

    @latitude.setter
    def latitude(self, latitude: float):
        """Sets the latitude of this Gateway.


        :param latitude: The latitude of this Gateway.
        :type latitude: float
        """
        if latitude is None:
            raise ValueError("Invalid value for `latitude`, must not be `None`")  # noqa: E501

        self._latitude = latitude

    @property
    def longitude(self) -> float:
        """Gets the longitude of this Gateway.


        :return: The longitude of this Gateway.
        :rtype: float
        """
        return self._longitude

    @longitude.setter
    def longitude(self, longitude: float):
        """Sets the longitude of this Gateway.


        :param longitude: The longitude of this Gateway.
        :type longitude: float
        """
        if longitude is None:
            raise ValueError("Invalid value for `longitude`, must not be `None`")  # noqa: E501

        self._longitude = longitude
